#!/usr/bin/php
<?php

/* Reminder: always indent with 4 spaces (no tabs). */
// +---------------------------------------------------------------------------+
// | Geeklog Add-ons                                                           |
// +---------------------------------------------------------------------------+
// | publishbymail.php
// |                                                                           |
// | Publishing a story by email                                               |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+
//
// $Id: publishbymail.php,v 1.8 2004/08/09 00:08:41 krichtof Exp $


require_once('/var/www/html/geeklog/lib-common.php');

// read from stdin
$fd = fopen("php://stdin", "r");
$email = "";
while (!feof($fd)) {
    $email .= fread($fd, 1024);
}
fclose($fd);

// handle email
$lines = explode("\n", $email);

// empty vars
$from = "";
$subject = "";
$headers = "";
$message = "";
$splittingheaders = true;

for ($i=0; $i<count($lines); $i++) {
    if ($splittingheaders) {
        // this is a header
        $headers .= $lines[$i]."\n";

        // look out for special headers
        if (preg_match("/^Subject: (.*)/", $lines[$i], $matches)) {
            $subject = $matches[1];
        }
        if (preg_match("/From: (.*)<(.*)>/", $lines[$i], $matches)) {
            $from = $matches[2];
        }
    } else {
        // not a header, but message
        $message .= $lines[$i]."\n";
    }

    if (trim($lines[$i])=="") {
        // empty line, header section has ended
        $splittingheaders = false;
    }
}

$message = addslashes(htmlspecialchars($message));
$subject = addslashes(htmlspecialchars($subject));
$sid = COM_makeSid();

$result = DB_query ("SELECT * FROM {$_TABLES['users']} WHERE email='$from'");
$userGeek = DB_fetchArray ($result);
if ($userGeek != NULL) {
$uid = $userGeek['uid'];
DB_save ($_TABLES['stories'], 'sid,uid,title,introtext,date,postmode,owner_id', "$sid,$uid,'$subject','$message',NOW(),'plaintext',$uid");
}
else {
COM_mail($from, 'Mail rejected', 'Forbidden to post !');
}

?>
